class Campaign {
    string name;
    string description;
    Medal@ medal;
    Trophy@ trophy;
    array<ChallengeMap@>@ maps;

    Campaign(string _name, string _description, Medal@ _medal, Trophy@ _trophy, array<ChallengeMap@>@ _maps) {
        name = _name;
        description = _description;
        @medal = _medal;
        @trophy = _trophy;
        @maps = _maps;

        for (uint i=0; i<maps.Length; i++) {
            maps[i].setCampaign(this);
        }
    }

    bool completed() {
        for (uint i=0; i<maps.Length; i++) {
            ChallengeMap@ cm = maps[i];
            if (!cm.achieved()) {
                return false;
            }
        }
        return true;
    }
}